﻿Enumeration
  #lv
  #bg
  #cw
EndEnumeration

Global v$="deUTF88 II 0.9b"
; If CreateRegularExpression(0, "[p,s]?htm[l]")
;   Debug MatchRegularExpression(0, "abC") ; Will print 1
;                                          ;Debug MatchRegularExpression(0, "abC") ; Will print 1
;                                          ;Debug MatchRegularExpression(0, "abc") ; Will print 0
; Else
;   Debug RegularExpressionError()
; EndIf


Procedure rc(d$,dl)
  If Mid(d$,Len(d$))<>"\"
    d$+"\"
  EndIf
  If ExamineDirectory(dl, d$, "*.*")
    While NextDirectoryEntry(dl)
      s$=DirectoryEntryName(dl)
      If DirectoryEntryType(dl) = #PB_DirectoryEntry_File
        If FindString(GetExtensionPart(s$),"htm")
          AddGadgetItem (#lv, -1,d$+s$);DirectoryEntryName(dl))
        EndIf
      Else
        If DirectoryEntryType(dl) = #PB_DirectoryEntry_Directory And s$<>"." And s$<>".."
          rc(d$+s$,dl+1)
        EndIf
      EndIf
    Wend
    FinishDirectory(dl)
  EndIf
  
EndProcedure

Procedure decod2()
  ci.l=CountGadgetItems(#lv)
  If ci
    For nn=0 To ci-1
      f$=GetGadgetItemText(#lv,nn)
      fs.l=FileSize(f$)
      SetWindowTitle(0,f$)
      *m=AllocateMemory(fs)
      If ReadFile(0,f$)
        ReadData(0,*m,fs)
        CloseFile(0)
        
        s.s=PeekS(*m,fs,#PB_UTF8)
        FreeMemory(*m)
        If CreateFile(0,f$)
          WriteString(0,s,#PB_Ascii)
          CloseFile(0)
        Else
          MessageRequester("file error","cant read"+#CRLF$+f$)
        EndIf
        
      Else
        MessageRequester("file error","cant write"+#CRLF$+f$)
      EndIf
      
      
    Next nn
  EndIf
EndProcedure

Procedure decod()
  ci.l=CountGadgetItems(#lv)
  If ci
    For nn=0 To ci-1
      f$=GetGadgetItemText(#lv,nn)
      fs.l=FileSize(f$)
      ;SetWindowTitle(0,f$)
      
      If ReadFile(0,f$)
        *m=AllocateMemory(fs+4)
        ReadData(0,*m,fs)
        CloseFile(0)
        
        p.l=0
        s.s=""
        ;WindowEvent()
        While p<=fs;For i=0 To fs
          SetWindowTitle(0,GetFilePart(f$)+":"+Str(p)+"/"+Str(fs))
          WindowEvent()
          ;   $h = ord($c{$index});
          h.l=PeekL(*m+p)&255
          ;   If ($h <= 0x7F) {
          If h<=127
            s+Chr(h)
            p+1
            ;     $bytes = 1;
            ;     Return $h;
            ;   }
          ElseIf h<$C2;   Else If ($h < 0xC2)
                      ;     Return false;
          ElseIf h<=$DF And p<fs-1;   Else If ($h <= 0xDF && $index < $len - 1) {
                                  ;     $bytes = 2;
                                  ;     Return ($h & 0x1F) <<  6 | (ord($c{$index + 1}) & 0x3F);
            s=s+Chr( ((h&$1F)<<6)|(PeekL(*m+p+1)&$3F) )
            p+2
            ;   }
          ElseIf h<=$EF And p<fs-2;   Else If ($h <= 0xEF && $index < $len - 2) {
                                  ;     $bytes = 3;
                                  ;     Return ($h & 0x0F) << 12 | (ord($c{$index + 1}) & 0x3F) << 6
                                  ;                              | (ord($c{$index + 2}) & 0x3F);
            s=s+Chr( ((h&$1F)<<12)|((PeekL(*m+p+1)&$3F)<<6 )|( PeekL(*m+p+2)&$3F) )
            p+3
            ;   }          
          ElseIf h<=$F4 And p<fs-3;   Else If ($h <= 0xF4 && $index < $len - 3) {
                                  ;     $bytes = 4;
                                  ;     Return ($h & 0x0F) << 18 | (ord($c{$index + 1}) & 0x3F) << 12
                                  ;                              | (ord($c{$index + 2}) & 0x3F) << 6
                                  ;                              | (ord($c{$index + 3}) & 0x3F);
            s=s+Chr( ((h&$0F)<<18)|((PeekL(*m+p+1)&$3F)<<12 )|( (PeekL(*m+p+2)&$3F)<<6 )|(PeekL(*m+p+3)&$3F) )
            ;   }
          Else;   Else
              ;     Return false;
          EndIf; }
        Wend   ;Next i
        
        If CreateFile(0,f$)
          
          WriteString(0,s,#PB_Ascii)
          CloseFile(0)
          FreeMemory(*m)
        Else
          MessageRequester("Error","can't write "+#CRLF$+f$)
        EndIf;If CreateFile(0,f$)
      Else
        MessageRequester("Error","can't open "+#CRLF$+f$)
      EndIf;If ReadFile(0,f$)
      
    Next nn
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, v$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ListViewGadget(#lv, 0, 0, 640, 400)
  ButtonGadget(#bg,0,400,640,20,"Go")
  CheckBoxGadget(#cw,0,420,640,20,"use PureBasic librariies")
  ;rc(PeekS(?fd,?fe-?fd,#PB_Ascii),0)
  EnableGadgetDrop(#lv,#PB_Drop_Files,#PB_Drag_Copy)
  Repeat
    ev=WaitWindowEvent()
    
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    
    If GetAsyncKeyState_(#VK_DELETE)=-32767
      ci.l=GetGadgetState(#lv)
      am.l=CountGadgetItems(#lv)
      ;Debug ci
      If ci<>-1
        RemoveGadgetItem(#lv,ci)
        If ci=0
          SetGadgetState(#lv,0)
        ElseIf ci=am-1
          SetGadgetState(#lv,CountGadgetItems(#lv)-1)
        Else
          SetGadgetState(#lv,ci)
        EndIf
      EndIf
    EndIf
    
    Select ev
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #bg:
            If GetGadgetState(#cw)
              decod2()
            Else
              decod()
            EndIf
            SetWindowTitle(0,v$)
        EndSelect
        
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        Count  = CountString(Files$, Chr(10)) + 1
        For ii = 1 To Count
          File$ = StringField(Files$, ii, Chr(10))
          If FileSize(File$)=-2 ;directory
            rc( File$ , 0 )
          Else
            AddGadgetItem( #lv, -1, File$ )
          EndIf
        Next ii
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf

; DataSection
;   fd:
;   IncludeBinary "fd.txt"
;   fe:
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 139
; FirstLine = 127
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = deutf2.ico
; Executable = deutf2.exe
; Watchlist = rc()>s$